﻿$engine JScript
$uname bookmarkers
$dname Закладки
$addin global
$addin stdlib
$addin stdcommands

//Скрипт получает список меток(определеннного формата) из модуля,
//чтобы быстро переходить к отмеченным местам в коде

stdlib.require("TextWindow.js",SelfScript);
global.connectGlobals(SelfScript);

var мФормаСкрипта;
//events.connect(Designer, "createTextWindow", SelfScript.Self);


function getBookMarkers(){

if (!BookMarkers._instance)
        new BookMarkers();
    
    return BookMarkers._instance;
 }
 
SelfScript.self['macrosОткрыть окно'] = function() {
	
	//debugger
	f = getBookMarkers();
	f.OpenWindow = true;
	f.update();	
}

function BookMarkers(){
	
	BookMarkers._instance = this;
	var pathToForm = SelfScript.fullPath.replace(/js$/, 'ssf');
	this.targetWindow = GetTextWindow();
	this.form = loadScriptForm(pathToForm, this)
	this.form.КлючСохраненияПоложенияОкна = SelfScript.uniqueName;
	this.watcher = new TextWindowsWatcher();
	this.OpenWindow = false;
}

BookMarkers.prototype.ТаблицаЗакладокВыбор = function(Элемент, ВыбраннаяСтрока, Колонка, СтандартнаяОбработка) {
	this.goToLine(ВыбраннаяСтрока.val);
    //СтандартнаяОбработка.val = false; // Это для того чтобы после нажатия на строку курсор не уходит с табличного поля, и при новой активизации формы можно было курсором посмотреть другие значения
}

BookMarkers.prototype.КоманднаяПанель1Обновить = function(Кнопка) {
	//debugger
    this.update();
}

BookMarkers.prototype.ПриЗакрытии = function(Кнопка) {
	//debugger
    this.OpenWindow = false;
}

BookMarkers.prototype.activateEditor = function () {
	
	if (this.targetWindow){
    var activeView = this.targetWindow.GetView() ;
    if (activeView)
        activeView.activate();}
}

BookMarkers.prototype.Close = function () {
    if (this.form.IsOpen())
    {
        this.form.Close();
        return true;
    }
    return false;
}

BookMarkers.prototype.IsOpen = function () {
    return this.form.IsOpen();
}

BookMarkers.prototype.goToLine = function (row) {

    this.form.Controls.ТаблицаЗакладок.ТекущаяСтрока = row;

    if (!this.targetWindow)
        return;
 
    if (!this.targetWindow.IsActive())
    {
        DoMessageBox("Окно, для которого показывался список, было закрыто!");
        this.form.ТаблицаЗакладок.Очистить();
        return;
    }
 	//debugger
    // Переведем фокус в окно текстового редактора.
    this.activateEditor();
    var textline = this.targetWindow.GetLine(row.НомерСтроки)
    // Установим выделение на найденное совпадение со строкой поиска.
    this.targetWindow.SetCaretPos(row.НомерСтроки, 1);
    this.targetWindow.SetSelection(row.НомерСтроки, 1, row.НомерСтроки, textline.length);
}

BookMarkers.prototype.update = function(){
		
	var text = "";
	var strlabel = "//Закладка{";
	
	var re = new RegExp('//Закладка{([^}]+)}|//\s*FIXME:(.*)|//\s*TODO:(.*)','igm');
	//debugger
	this.targetWindow = this.watcher.getActiveTextWindow();
	
	if (!this.OpenWindow) return;
	
	if (this.targetWindow){ 
		// Проверим, не открывается ли это какое-либо дочернее окно из конструктора запросов.
		if (this.targetWindow.textWindow.mdCont == null)
		return;

		form = this.form;
		//debugger
		var ЗаголовокФормы = "";
		var text1 = this.targetWindow.textWindow.mdCont.rootObject.name;
		var text2 = this.targetWindow.textWindow.mdObj.name;
		if (text2.indexOf("Форма")>=0) ЗаголовокФормы = text1;
			else ЗаголовокФормы = text2;
		form.Заголовок = "Закладки " + ЗаголовокФормы;
		form.Открыть();
		form.ТаблицаЗакладок.Очистить();
		
		var lines = StringUtils.toLines(this.targetWindow.textWindow.text);
		for(var lineIx = 1; lineIx < lines.length; lineIx++)
			{
			text = lines[lineIx];
			while((Matches = re.exec(text)) != null) {
                //Message(""+Matches[0]+" 1 "+Matches[1]+Matches[2]+Matches[3]);
                Message(""+Matches[1]);
				str1 = text.substr(Matches.index+strlabel.length, Matches.lastIndex - (Matches.index+strlabel.length));
                str1 = ""+Matches[1]+Matches[2]+Matches[3];
				str1 = str1.replace("}", "")
				НоваяСтрока = form.ТаблицаЗакладок.Добавить();
				НоваяСтрока.НомерСтроки = "" + (lineIx+1);
				НоваяСтрока.ИмяЗакладки = str1;
				}
				}
				}
}

//function createTextWindow(textWnd) {
//	
//	//debugger
//	// Проверим, не открывается ли это какое-либо дочернее окно из конструктора запросов.
//	if (textWnd.extName == "Язык запросов")
//		return;
//	
//	// различные диалоги из скриптов
//	if (!textWnd.extName.length || (textWnd.readOnly && !textWnd.text.length && textWnd.extName == "Встроенный язык"))
//		return;
//	
//	try 
//	{
//		//text = textWnd.GetText();
//		f = getBookMarkers();
//		f.update();
//	}
//	catch (e) 
//	{
//		// do nothing
//	}    
//}

////////////////////////////////////////////////////////////////33////////////////////////
////{ TextWindowsWatcher - отслеживает активизацию текстовых окон и запоминает последнее.
////

function TextWindowsWatcher() {
    this.timerId = 0;
    this.lastActiveTextWindow = null;
    this.startWatch();
}

TextWindowsWatcher.prototype.getActiveTextWindow = function () {
    if (this.lastActiveTextWindow && this.lastActiveTextWindow.IsActive())
        return this.lastActiveTextWindow;
    return null;
}

TextWindowsWatcher.prototype.startWatch = function () {
    if (this.timerId)
        this.stopWatch();
    this.timerId = createTimer(500, this, 'onTimer');
}

TextWindowsWatcher.prototype.stopWatch = function () {
    if (!this.timerId)
        return;
    killTimer(this.timerId);
    this.timerId = 0;
}

TextWindowsWatcher.prototype.onTimer = function (timerId) {
    var wnd = GetTextWindow();    
    if (wnd){
		if (this.lastActiveTextWindow){
			if (wnd.textWindow.textMgr != this.lastActiveTextWindow.textWindow.textMgr){
			this.lastActiveTextWindow = wnd;
			//debugger
			f = getBookMarkers();
			f.update();
			f.activateEditor();}}
		else {this.lastActiveTextWindow = wnd;
		f = getBookMarkers();
			f.update();
			f.activateEditor();}
		}
    else if (this.lastActiveTextWindow && !this.lastActiveTextWindow.IsActive())
        this.lastActiveTextWindow = null;
}
//} TextWindowsWatcher 


////////////////////////////////////////////////////////////////////////////////////////
////{ TextWindowsWatcherGoToLine - отслеживает активизацию текстовых окон и запоминает последнее и переходим по строке.
////

TextWindowsWatcherGoToLine = stdlib.Class.extend({

    construct : function(LineNo, LineToFind) {
        this.timerId = 0;
        this.lastActiveTextWindow = null;
        this.Line = LineNo;
        if (LineToFind == undefined){
            this.Name = "";
        } else {
            this.Name = LineToFind;    
        }
        this.startWatch();
    },

    getActiveTextWindow : function () {
        if (this.lastActiveTextWindow && this.lastActiveTextWindow.IsActive())
            return this.lastActiveTextWindow;
        return null;
    },

    startWatch : function () {
        if (this.timerId)
            this.stopWatch();
        this.timerId = createTimer(1*300, this, 'onTimer');
    },

    stopWatch : function () {
        if (!this.timerId)
            return;
        killTimer(this.timerId);
        this.timerId = 0;
    },
    
    goToLine : function() {
        if (!this.Line)
            return
        
        wnd = this.getActiveTextWindow()
        if (wnd){
            var LineNo = this.Line;

            var lines = StringUtils.toLines(wnd.GetText());
            for(var lineIx = LineNo; lineIx < lines.length; lineIx++)
            {
                var line = lines[lineIx];
                var index = line.indexOf(this.Name);
                if (index>=0){
                    // Переведем фокус в окно текстового редактора.
                    wnd.SetCaretPos(lineIx+1, index+1);
                    wnd.SetSelection(lineIx+1, index+1, lineIx+1, index+1+this.Name.length);
                    return;
                }
            }

            var textline = wnd.GetLine(LineNo+1);
            wnd.SetCaretPos(LineNo+2, 1);
            wnd.SetSelection(LineNo+1, 1, LineNo+1, textline.length-1);
        }
    },

    onTimer : function (timerId) {
        var wnd = GetTextWindow();    
        if (wnd){
            this.lastActiveTextWindow = wnd;
            this.goToLine()
        }
        this.stopWatch();
    }
    
}); 
//} end of TextWindowsWatcherGoToLine class